//Julia-Menge zu z -> f(z)/g(z)  mit f(z) = z^8-3z^3+cos(z)+c und g(z) = z^6 + sin(z); (4a)
//Mit Tasten <1>...<4> wählt man das gewünschte Bild
//1: Julia4 mit Winkeldifferenz-Farbgebung
//2: JuliaMenge Konvergenzbild
//3:JuliaNewton mit 9-Kreise Traps
//4: Julia-Menge lokalisieren (weiß auf schwarz)
//Linksklick zoomen an angeklickte Stelle
//Taste <c> wählt einen zufälligen c-Wert.

//Weitere Informationen:  https://ningelgen.eu
/////////////////////////////////////////////////////////////////////////////////////////////////////////
ArrayList<Threads> threads;

Complex zNeu,zAlt,z,z0,z1,C,zA,zB,zfZaehlerNewton,zF;
ArrayList<Complex> fixpunkte;
FarbTafel farben;
double zR,zI;
//double xU = -2; double yU = -2; double xO = 2;double yO = 2;
double xU = -7.2; double yU = -7.2; double xO = 7.2; double yO = 7.2;
//double xU = -36; double yU = -36; double xO = 36;double yO = 36;
//double xU = -72; double yU = -72; double xO = 72;double yO = 72;
double zoomFaktor=1;
double wh = xO-xU;
double x0,y0;
double laenge;
double a,b; //Fixpunkte
float aP,bP;//...und ihre Koordinaten
boolean FPzeichnen = false;
boolean farbig = false;//Unterscheidung verschiedener Orbitpunkte
boolean orbitZeichnen = false;
int Selektor;
int maxiterations = 500;//Iterationsgrenze 
int anzahlFixpunkte = 9; //...im vorgegebenen Bereich (innerhalb Ursprungskreis mit Radius radiusFixpunkte) - größtmögliche Zahl muss man testen
int maxFPIteration = 10*maxiterations;//Iterationsgrenze beim Suchen der Fixpunkte. Je mehr Fixpunkte desto höher wählen
int anzahlOrbits = 1000;//1000
int orbitZeichnenAb ;
int orbitZeichnenBis;
int punktGroesse;
double massFuerUnendlich = 1e16;
double e = 0.001; //Abstand, ab dem der Orbitpunkt als zugehöriger Fixpunkt gilt
int nummerThread;
int anzahlThreads = Runtime.getRuntime().availableProcessors(); 
double gW = 60;
color farbe,fpFarbe;//Farbe für Orbits und Fixpunkte


void setup() {
  background(255); 
  colorMode(RGB);
  threads = new  ArrayList<Threads>();   
  fixpunkte = new ArrayList<Complex>();
  farben= new FarbTafel();
  farben.farbTafelErzeugen();  
  size(800, 800);
  //c-Wert
  x0=-0.3; y0=0.5;
  C = new Complex(x0,y0);
  z0 = new Complex(0,0);
  Selektor = 1 ;
  
  starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0,
                Selektor, e); 
}

/////////////////////////////////////////////////////////////////
void starteThreads(double px, double py, int pmaxiterations, double pUnendlich, double pwh, int nummer, double X0, double Y0, 
                   int selektor, double e){
  
  xU = px; yU = py;
  x0 = X0; y0 = Y0;
  nummerThread = nummer;
  maxiterations = pmaxiterations;
  massFuerUnendlich = pUnendlich;
  Selektor = selektor;
  wh = pwh;
  double  y= yO-wh/anzahlThreads;
  while(nummerThread <anzahlThreads){
        Threads t = new Threads(xU,y,maxiterations,massFuerUnendlich,wh/anzahlThreads, nummerThread,x0,y0,
                        selektor, e);
        threads.add(t);
        t.start(); 
        nummerThread++;
        y=y-wh/anzahlThreads;
        delay(200);//zur Verringerung der Pixelfehler 
  }  
}
//////////////////////////////////////////////////////////////
void draw() {
 
  for(Threads t: threads){
      while (t.running){       
            try{
            Thread.sleep(10);  
            }catch (Exception e) {  }  ;                
       }
       if(t.gibNummer() ==0)println("fertig!");
       noLoop();
  }
  
  for (int i=0; i<threads.size(); i++){
    image(threads.get(i).pg,0,i*height/anzahlThreads);  
  }  
  
  if(orbitZeichnen){
     
      juliaIteration(z0,orbitZeichnenAb,orbitZeichnenBis );  
      orbitZeichnen = false;
      farbig = false;
  }
  
  if(FPzeichnen){
    println("Fixpunkte eintragen");
    if(fixpunkte.size() ==0){
          zyklischeFixPunkteBestimmen();
      }
    
    for(int l =0; l<anzahlFixpunkte;l++){
      fixPunktEintragen(fixpunkte.get(l));
    }
    FPzeichnen = false;
  }
  
}
///////////////////////////////////////////////////////////////////////
void zyklischeFixPunkteBestimmen(){ 
  boolean fpGefunden = false;
  while(!fpGefunden){
    zAlt = new Complex(random(-10,10),random(-10,10)); println(zAlt);
    for(int i=0; i<500;i++){
      zNeu = JuliaIteration(zAlt,1); 
      if(i>490){ fixpunkte.add(zNeu);fpGefunden=true;} //println(i,zNeu);
      if(abs((float)zNeu.getImaginaryPart()) >300){println("Ausstieg bei "+i); break;}
      zAlt = zNeu;
    }
  }
   println("zyklische Fixpunkte:"); 
  for( Complex fp: fixpunkte){
     println(fp);
  }
 
}
//////////////////////////////////////////////////////////

void fixPunktEintragen(Complex Z1 ){  
  
  strokeWeight(8); 
  stroke(fpFarbe);
  a = Z1.getRealPart();
  b = Z1.getImaginaryPart();
  aP = map((float)a,(float)xU,(float)xO,0,width);
  bP = map((float)b,(float)yU,(float)yO,height,0); 
  point(aP,bP); 
}
//////////////////////////////////////////////////////////////////////
int juliaIteration(Complex Z, int M, int N) {//...um einen Orbit zu zeichnen ..ab ..bis
  int n = 0;
  a = Z.getRealPart();
  b = Z.getImaginaryPart(); 
  zAlt = new Complex(a,b);     println(zAlt);
  if(farbig) {
     colorMode(HSB,255,255,255);
     farbe = color(random(0,255),255,255);
     stroke(farbe);
     
   }else{
      stroke(0,255,0);
      colorMode(RGB, 255,255,255);
    }   
  aP = map((float)a,(float)xU,(float)xO,0,width);
  bP = map((float)b,(float)yU,(float)yO,height,0); 
  strokeWeight(punktGroesse+2);
  point(aP,bP);//Startpunkt
  
  while (n < N) {
    a = zAlt.getRealPart();
    b = zAlt.getImaginaryPart();
    if(Math.abs(a) > 100000 || Math.abs(b) > 300) {
        println("out by "+n);break;
      }//Kontrolle
    
    zNeu = JuliaIteration(zAlt,1);   
    laenge = zNeu.getLength(); //println("Exakt "+n,zNeu,laenge);
       
    a = zNeu.getRealPart();
    b = zNeu.getImaginaryPart();
    if(orbitZeichnen && n > M-2 ){   
      //if(n<10 || n>N-10)println(n,zNeu);      
      aP = map((float)a,(float)xU,(float)xO,0,width);
      bP = map((float)b,(float)yU,(float)yO,height,0);
      if(farbig) stroke(farbe);
        else stroke(255,0,0);
      strokeWeight(punktGroesse);
      point(aP,bP);
    }
    zAlt = new Complex(a,b);println(zAlt);
    n++; 
  }
  colorMode(RGB);
  return n;
 }

////////////////////////////////////////////////////////////////////
void mousePressed() { 
     nummerThread =0;
     threads = new  ArrayList<Threads>(); 
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
         
      if (mouseButton == LEFT&& keyCode == SHIFT){ //Angeklickte Stelle zoomen
          xUNeu = map(mouseX,0,width,(float)xU,(float)xO)-(xO-xU)/10;
          xONeu = map(mouseX,0,width,(float)xU,(float)xO)+(xO-xU)/10; 
          xU = xUNeu; xO = xONeu; 
          yUNeu = map(mouseY,height,0,(float)yU,(float)yO)-(yO-yU)/10;
          yONeu = map(mouseY,height,0,(float)yU,(float)yO)+(yO-yU)/10; 
          yU =yUNeu; yO = yONeu; 
          wh = wh/5;
          e = e/2;//epsilon
          zoomFaktor =zoomFaktor*5;
          println("Zoomfaktor: "+zoomFaktor);
          starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0, 
                        Selektor,e);  
          redraw();
        
     }
   if (mouseButton == RIGHT){   
     if (keyPressed == true && keyCode == SHIFT){//Orbit von Beginn an einzeichnen
          orbitZeichnen = true;
          farbig = true;//bei jedem Klick neue Farbe
          orbitZeichnenAb = 1;
          orbitZeichnenBis = 50000;//2000000;
          punktGroesse =3;
          orbitZeichnen = true;
          float xH = map(mouseX,0,width,(float)xU,(float)xO); 
          float yH = map(mouseY,0,height, (float)yO,(float)yU);
          z0 = new Complex(xH,yH);
          if(fixpunkte.size() >0){println("Anzahl der Fixpunkte "+fixpunkte.size());
            FPzeichnen = true;
            for(int l =0; l<anzahlFixpunkte;l++){
                 fixPunktEintragen(fixpunkte.get(l));
            }
            FPzeichnen = false;
          }
          println("Orbit Punkte zeichnen von Beginn bis "+orbitZeichnenBis);
          redraw();
         
     }else if (keyPressed == false){ //Orbit ab Element orbitZeichnenAb einzeichnen
          orbitZeichnen = true;
          orbitZeichnenAb  = 1;// 49000;
          orbitZeichnenBis = 100;//50000;
          punktGroesse =2;   
          farbig = true;
          orbitZeichnen = true;
          float xH = map(mouseX,0,width,(float)xU,(float)xO); 
          float yH = map(mouseY,0,height, (float)yO,(float)yU);
          z0 = new Complex(xH,yH);
          println("Orbit Punkte zeichnen ab n = "+ orbitZeichnenAb);
          redraw();
     }
 }  
}
/////////////////////////////////////////////////////////////////
void keyPressed() {
 
  if (key == 'c'){
      println("Zufälligen C-Wert wählen");
      x0=random(-8,8); y0=random(-8,8);//C-Wert
      C = new Complex(x0,y0);
      nummerThread =0;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0,
                    Selektor,e);
      redraw();
  }
  
   if (key == 'f'){//Fixpunkte einzeichnen (nur sichtbar -10 ...10 Bereich)
      fpFarbe = color(255);
      if(fixpunkte.size() ==0){
           fixpunkte = new ArrayList<Complex>();
      }
      println("Fixpunkte im Bereich x "+xU,xO+"  y "+yU,yO);
      FPzeichnen=true;
      redraw();
  }
    
  if (key == '1'){//Fatou-Gebiete farbig einzeichnen
      nummerThread =0;
      //xU = -36; xO = 36; yU = -36; yO = 36;
      xU = -2; xO = 2; yU = -2; yO = 2;
      println("Fatou-Gebiete eintragen");
      Selektor = 1; 
      nummerThread =0;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                    Selektor,e);
      redraw();
  }   
  
  if (key == '2'){//Julia-Menge Konvergenzgeschwindigkeit
      nummerThread =0;
      xU = -36; xO = 36; yU = -36; yO = 36;
     // xU = -2; xO = 2; yU = -2; yO = 2;
      wh = xO-xU;
      println("Julia-Menge Konvergenzgeschwindigkeit");
      fpFarbe = color(255);
      Selektor = 2;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                    Selektor,e);
      redraw();
  }  
  
   if (key == '3'){//Fatou-Gebiete farbig einzeichnen und Julia-Menge mit 9-Kreise-Traps
      nummerThread =0;
      println("2Julia Fraktal mit Traps");
      Selektor = 3;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                    Selektor,e);
      redraw();
  }  
  
  if (key == '4'){//Julia-Menge weiß auf schwarzem Hintergrund
      nummerThread =0;
      //xU = -2; yU = -2; xO = 2;yO = 2;
      xU = -36;  yU = -36;  xO = 36; yO = 36;
      println("Julia-Menge weiß auf schwarzem Hintergrund");
      Selektor = 4;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                    Selektor,e);
      redraw();
  }  
  
  if (key == 'o'){//Orbits 
       
        for(int i=0;i<anzahlOrbits;i++){
          
          orbitZeichnen = true;
          farbig = true;//bei jedem Klick neue Farbe
          orbitZeichnenAb = 1;
          orbitZeichnenBis = 50000; //20000;
          punktGroesse =1;
          float xH = random((float)xU,(float)xO);
          float yH = random((float)yU,(float)yO);
          z0 = new Complex(xH,yH);
          juliaIteration(z0,orbitZeichnenAb,orbitZeichnenBis);
          println(i);
         
       redraw();
        }
         if(fixpunkte.size() >0){println("Anzahl der Fixpunkte "+fixpunkte.size());
            fpFarbe = color(255);
            FPzeichnen = true;
            for(int l =0; l<anzahlFixpunkte;l++){
                 fixPunktEintragen(fixpunkte.get(l));
            }
            FPzeichnen = false;
          }
           println("Orbit Punkte zeichnen von Beginn bis "+orbitZeichnenBis);
      }
     
  if (key == '+'){//Iterationsgrenze erhöhen
     nummerThread =0;
     maxiterations *= 2; println("Iterationsgrenze: "+maxiterations);
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Selektor,e);
  }
  if (key == '-') {//Iterationsgrenze veringern
      nummerThread =0;
      maxiterations /= 2;println("Iterationsgrenze: "+maxiterations);
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                    Selektor,e);  
  }
//Die folgenden Aktionen betreffen zoomen und verschieben des Bildes//////////////////////////////// 
  if (key == 'z'){//zoomen in der Mitte
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
     nummerThread =0;
     xUNeu = xU+0.25*(xO-xU);yUNeu = yU+0.25*(yO-yU);
     xONeu = xO-0.25*(xO-xU);yONeu = yO-0.25*(yO-yU);
     xU = xUNeu;xO = xONeu; 
     yU =yUNeu; yO = yONeu; 
     wh=wh/2;
     zoomFaktor =zoomFaktor*2;
     println("Zoomfaktor: "+zoomFaktor);
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Selektor,e);
  }
  if (key == 'l'){//Bild nach links verschieben
     nummerThread =0;
     xO = xO + wh/10;
     xU = xU + wh/10;
     println("Verschiebung nach Links");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Selektor,e);
  }
  if (key == 'r'){//Bild nach rechts verschieben
     nummerThread =0;
     xO = xO - wh/10;
     xU = xU - wh/10;
     println("Verschiebung nach Rechts");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Selektor,e);
  }
   if (key == 'u'){//Bild nach unten verschieben
     nummerThread =0;
     yO = yO + wh/10;
     yU = yU + wh/10;
     println("Verschiebung nach unten");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Selektor,e);
  }
  if (key == 'o'){//bild nach oben verschieben
     nummerThread =0;
     yO = yO - wh/10;
     yU = yU - wh/10;
     println("Verschiebung nach oben");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Selektor,e);
  }
  ///Bild speichern/////////////////////////////////////////////////////////////////////////
  if (key == 's') save("julia.png");
  redraw();
}

//Iterations-Algorithmus/////////////////////////////////////////////////////////////////
 Complex JuliaIteration(Complex zAlt, int M){//Newton-Iteration 
 
   for(int i =0; i< M;i++){
      zNeu = f(zAlt,C).divide(g(zAlt));
      zAlt = zNeu;               // println(zNeu);
   }
  return zAlt;
 }
 Complex f(Complex zAlt,Complex C){    //Zähler Newton-Iteration
      
      Complex zaehler = new Complex(0,0);
      zaehler = zAlt.power(8);//z^8
      zaehler = zaehler.addC(C);//z^8+c 
      zaehler = zaehler.subtractC((zAlt.power(3)).multiply(3));//z^8-3z^3+c 
      zaehler = zaehler.addC(zAlt.cosC());//z^8-3z^3+cos(z)+c
      return zaehler;
 }
 Complex g(Complex zAlt){               //Nenner Newton-Iteration
      Complex nenner = new Complex(0,0);
      nenner = zAlt.power(6);//z^6
      nenner = nenner.addC(zAlt.sinC());//z^6+sin(z)
      if(nenner.getLength() < 0.000000001) nenner = new Complex(0.000001,0.000001);//Nenner 0 vermeiden
      return nenner;
 }
